---
title: OscillatorNode.type
slug: Web/API/OscillatorNode/type
tags:
  - API
  - OscillatorNode
  - Property
  - Reference
  - Type
  - Web Audio API
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <strong><code>type</code></strong> property of the {{ domxref("OscillatorNode") }} interface specifies what shape of {{interwiki("wikipedia", "waveform")}} the oscillator will output. There are several common waveforms available, as well as an option to specify a custom waveform shape. The shape of the waveform will affect the tone that is produced.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>OscillatorNode</em>.type = <em>type</em>;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} specifying the shape of oscillator wave. The different available values are:</p>

<dl>
 <dt><code>sine</code></dt>
 <dd>A {{interwiki("wikipedia", "sine wave")}}. This is the default value.</dd>
 <dt><code>square</code></dt>
 <dd>A {{interwiki("wikipedia", "square wave")}} with a {{interwiki("wikipedia", "duty cycle")}} of 0.5; that is, the signal is "high" for half of each period.</dd>
 <dt><code>sawtooth</code></dt>
 <dd>A {{interwiki("wikipedia", "sawtooth wave")}}.</dd>
 <dt><code>triangle</code></dt>
 <dd>A {{interwiki("wikipedia", "triangle wave")}}.</dd>
 <dt><code>custom</code></dt>
 <dd>A custom waveform. You never set <code>type</code> to <code>custom</code> manually; instead, use the {{domxref("OscillatorNode.setPeriodicWave", "setPeriodicWave()")}} method to provide the data representing the waveform. Doing so automatically sets the <code>type</code> to <code>custom</code>.</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The value <code>custom</code> was specified. To set a custom waveform, just call {{domxref("OscillatorNode.setPeriodicWave", "setPeriodicWave()")}}. Doing so automatically sets the type for you.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following example shows basic usage of an {{ domxref("AudioContext") }} to create an oscillator node. For an applied example, check out our <a href="https://mdn.github.io/violent-theremin/">Violent Theremin demo</a> (<a href="https://github.com/mdn/violent-theremin/blob/gh-pages/scripts/app.js">see app.js</a> for relevant code).</p>

<pre class="brush: js;highlight[7]">// create web audio api context
var audioCtx = new (window.AudioContext || window.webkitAudioContext)();

// create Oscillator node
var oscillator = audioCtx.createOscillator();

oscillator.type = 'square';
oscillator.frequency.setValueAtTime(440, audioCtx.currentTime); // value in hertz
oscillator.start();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-oscillatornode-type', 'type')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.OscillatorNode.type")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
